# moderngl_window.finders

class moderngl_window.finders.base.BaseFilesystemFinder

  Base class for searching filesystem directories

  find(path: Path) → Path | None

    Finds a file in the configured paths returning its absolute path.

    Parameters:

      path (pathlib.Path) – The path to find

    Returns:

      The absolute path to the file or None if not found

  settings_attr = ''

    Name of the attribute in `Settings` containing a list of paths the finder should search in.

    Type:

      str

## Data

class moderngl_window.finders.data.FilesystemFinder

  Find data in `settings.DATA_DIRS`

  settings_attr = 'DATA_DIRS'

    Name of the attribute in `Settings` containing a list of paths the finder should search in.

    Type:

      str

## Program

class moderngl_window.finders.program.FilesystemFinder

  Find shaders in `settings.PROGRAM_DIRS`

  settings_attr = 'PROGRAM_DIRS'

    Name of the attribute in `Settings` containing a list of paths the finder should search in.

    Type:

      str

## Scene

class moderngl_window.finders.scene.FilesystemFinder

  Find scenes in `settings.SCENE_DIRS`

  settings_attr = 'SCENE_DIRS'

    Name of the attribute in `Settings` containing a list of paths the finder should search in.

    Type:

      str

## Texture

class moderngl_window.finders.texture.FilesystemFinder

  Find textures in `settings.TEXTURE_DIRS`

  settings_attr = 'TEXTURE_DIRS'

    Name of the attribute in `Settings` containing a list of paths the finder should search in.

    Type:

      str